package main

import (
	"fmt"
	"unicode"
	"unicode/utf8"
)

var data = ` Сообщения с телеграм канала Go-go!
я, извините, решил, что вы хоть что-то про регулярки знаете 🙂
С Почтением, с уважением 🙂.

Сообщения с телеграм канала Go-get job:
#Вакансия #Vacancy #Удаленно #Remote #Golang #Backend  
👨‍💻  Должность: Golang Tech Lead
🏢  Компания: PointPay
💵  Вилка: от 9000 до 15000 $ до вычета налогов
🌏  Локация: Великобритания
💼  Формат работы: удаленный
💼  Занятость: полная занятость 

Наша компания развивает 15 продуктов в сфере блокчейн и криптовалюты, функционирующих в рамках единой экосистемы. Мы - одни из лучших в своей нише, и за без малого три года мы создали криптовалютную платформу, которая предоставляет комплексные решения и позволяет пользователям проводить практически любые финансовые операции.
Наш проект победил в номинации "лучший блокчейн-стартап 2019 года" на одной из самых крупных конференций по блокчейн, криптовалютам и майнингу – Blockchain Life в Москве.

У нас очень амбициозные планы по развитию наших продуктов, и на данный момент мы находимся в поиске Golang Technical Lead, чтобы вместе создать революционный и самый технологичный продукт в мире.


  
Мы ожидаем от тебя:  
  
✅ Опыт управления финансовыми IT продуктами;
✅ Опыт постановки задач технической команде и приема результатов;
✅ Понимание и использование современных подходов к разработке (Agile);
✅ Опыт разработки не менее 5 лет;
✅ Отличное владение Go, будет плюсом опыт работы на PHP;
✅ Опыт работы с REST / GRPС (protobuf);
✅ Опыт работы с Laravel;
✅ Отличные навыки SQL (мы используем PostgreSQL);
✅ Опыт работы с Redis или аналогичной системой кеширования;
✅ Опыт работы с Kubernetes, с брокерами сообщений (RabbitMQ, Kafka и др.);
✅ Базовые знания Amazon Web Services.

Будем плюсом:

✅ Опыт разработки криптовалютных кошельков / криптовалютных бирж / криптовалютных торговых роботов / криптовалютных платежных систем или опыт работы в FinTech или банковских продуктах.

Чем предстоит заниматься:  
  
📌 Управлением и взаимодействием с командой;
📌 Постановкой задач команде разработчиков;
📌 Разработкой решений для запуска и сопровождения разрабатываемого компанией ПО;
📌 Выстраиванием эффективного процесса разработки;
📌 Достигать результатов, поддерживать и развивать текущие проекты, развивать новые проекты и продукты, искать и предлагать нестандартные решения задач.

Мы гарантируем будущему коллеге:  
  
🔥 Высокую заработную плату до 15 000$ (в валюте);
🔥 Индексацию заработной платы;
🔥 Полностью удаленный формат работы и максимально гибкий график - работайте из любой точки мира в удобное вам время;
🔥 Оформление по бессрочному международному трудовому договору с UK;
🔥 Отсутствие бюрократии и кучи бессмысленных звонков;
🔥 Корпоративную технику за счет компании;
🔥 Сотрудничество с командой высококвалифицированных специалистов, настоящих профессионалов своего дела;
🔥 Работу над масштабным, интересным и перспективным проектом.


Если в этом описании вы узнали  себя - пишите. Обсудим проект, задачи и все детали :)  
  
Павел,  
✍️TG: @pavel_hr  
📫 papolushkin.wanted@gmail.com`

func main() {
	if !utf8.ValidString(data) {
		return
	}
	fmt.Println("Кол-во символов:", utf8.RuneCountInString(data))
	for tdata, size, r, b := data, 0, ' ', 0; utf8.RuneCountInString(tdata) > 0; {
		r, size = utf8.DecodeRuneInString(tdata)
		if unicode.Is(unicode.So, r) {
			data = data[:b] + "=)" + data[b+size:]
			b += 2
		} else {
			b += size
		}
		tdata = tdata[size:]
	}
	show()
	cyr := len(data)
	translit := map[string]string{"Аа": "Aa", "Бб": "Bb", "Вв": "Vv", "Гг": "Gg", "Дд": "Dd", "Ее": "Ee", "Ёё": "Yoyo", "Жж": "Zhzh", "Зз": "Zz", "Ии": "Ii", "Йй": "Yy", "Кк": "Kk", "Лл": "Ll", "Мм": "Mm", "Нн": "Nn", "Оо": "Oo", "Пп": "Pp", "Рр": "Rr", "Сс": "Ss", "Тт": "Tt", "Уу": "Uu", "Фф": "Ff", "Хх": "Hh", "Цц": "Tsts", "Чч": "Chch", "Шш": "Shsh", "Щщ": "Shchshch", "Ъъ": "\"\"", "Ыы": "Yy", "Ьь": "''", "Ээ": "Ee", "Юю": "Yuyu", "Яя": "Yaya"}
	for tdata, size, r := "", 0, ' '; utf8.RuneCountInString(data) > 0; {
		r, size = utf8.DecodeRuneInString(data)
		data = data[size:]
		if unicode.Is(unicode.Cyrillic, r) {
			if v, ok := translit[string(unicode.ToUpper(r))+string(unicode.ToLower(r))]; ok {
				if unicode.IsUpper(r) {
					tdata += v[:len(v)/2]
				} else {
					tdata += v[len(v)/2:]
				}
			}
		} else {
			tdata += string(r)
		}
		if len(data) <= 0 {
			data = tdata
			break
		}
	}
	fmt.Print("\n\n-------------------------\n\n\n")
	show()
	lat := len(data)
	fmt.Print("\n-------------------------\n")
	fmt.Println("Компрессия текста (латиница/кирилица):", float64(lat)/float64(cyr))

}

func show() {
	for tdata, size, r, b := data, 0, ' ', 0; utf8.RuneCountInString(tdata) > 0; {
		r, size = utf8.DecodeRuneInString(tdata)
		tdata = tdata[size:]
		if r == '\n' {
			fmt.Println("[" + fmt.Sprint(b) + "]")
			b = 0
		} else if unicode.IsGraphic(r) && !unicode.IsMark(r) {
			fmt.Print(string(r))
			b++
		}
		if utf8.RuneCountInString(tdata) <= 0 {
			fmt.Println("[" + fmt.Sprint(b) + "]")
		}
	}
}
